/* Sophos Anti-Virus for OS/2
   MkAction 1.00   January 2001
   Copyright (c) 2000,01 Sophos Plc, www.sophos.com
   Convert response file to action file. */

"@ECHO OFF"

PARSE ARG ResponseFile ActionFile Rest
IF ActionFile = "" | Rest \= "" THEN
	EXIT 1

CALL RxFuncAdd "SysLoadFuncs", "RexxUtil", "SysLoadFuncs"
CALL SysLoadFuncs

CALL DeleteFile ActionFile
CALL Output ActionFile, "[Components]"
DO WHILE LINES(ResponseFile) > 0
	Line = STRIP(LINEIN(ResponseFile))
	IF TRANSLATE(LEFT(Line, 4)) = "COMP" THEN DO
		PARSE VALUE Line WITH Keyword "=" Name
		CALL Output ActionFile, STRIP(Name) || "=Yes"
	END
	ELSE DO
		PARSE VALUE Line WITH Prefix ";" Keyword "=" Name
		IF Prefix = "" & Keyword = "COMP" THEN
			CALL Output ActionFile, STRIP(Name) || "=No"
	END
END

EXIT 0


Output: PROCEDURE
	PARSE ARG File, Line
	IF LINEOUT(File, Line) \= 0 THEN
		EXIT 1
	RETURN

DeleteFile: PROCEDURE
	ARG Filename
	"IF EXIST" Filename "DEL" Filename
	IF RC > 0 THEN
		EXIT 1
	RETURN
