/* Sophos Anti-Virus for OS/2
   StartSAV 1.20   February 2003
   Copyright (c) 2000,03 Sophos Plc, www.sophos.com
   Start Sophos Anti-Virus for OS/2 if installation is not invalid. */

PARSE ARG StatusFile Params
IF StatusFile = "" THEN
    EXIT 1

CALL RxFuncAdd "SysLoadFuncs", "RexxUtil", "SysLoadFuncs"
CALL SysLoadFuncs

StatusValue = GetStatusValue(StatusFile)
IF StatusValue = 0 THEN
    CALL StartSweep Params
ELSE IF StatusValue = -1 | StatusValue // 4 = 1 THEN
    CALL DisplayInvalidError

EXIT 0

StartSweep: PROCEDURE
    ARG Params
    Path = GetSweepPath()
    IF Path \= "" THEN DO
        SIGNAL ON FAILURE NAME NoSweepExe
        SIGNAL ON ERROR NAME NoSweepExe
        "SET BEGINLIBPATH=" || Path || ";%BEGINLIBPATH%"
        "@START" Path Params "2>NUL"
        SIGNAL OFF ERROR
        SIGNAL OFF FAILURE
    END
    RETURN

NoSweepExe:
    Topic = "SWEEP.EXE was not found"
    Path = GetInfoPath()
    IF FileExists(Path) THEN
        "VIEW" Path """" || Topic || """"
    ELSE DO
        SAY "Sophos Anti-Virus for OS/2 cannot be started."
        SAY ""
        SAY "Program SWEEP.EXE does not exist or could not be run."
        SAY ""
        SAY "Please update Sophos Anti-Virus or consult your system administrator."
        SAY ""
        "@PAUSE"
    END
    EXIT 1

GetSweepPath: PROCEDURE
    Path = ""
    Dir = GetSavDirectory()
    IF Dir \= "" THEN DO
        IF RIGHT(Dir, 1) \= "\" THEN
            Dir = Dir || "\"
        Path = Dir || "SWEEP.EXE"
    END
    RETURN Path

DisplayInvalidError: PROCEDURE
    Topic = "SAV installation is invalid"
    Path = GetInfoPath()
    IF FileExists(Path) THEN
        "VIEW" Path """" || Topic || """"
    ELSE DO
        SAY "Sophos Anti-Virus for OS/2 cannot be started."
        SAY ""
        SAY "This can be because:"
        SAY ""
        SAY "- A manual install, update or remove operation failed, was interrupted"
        SAY "  or was cancelled."
        SAY ""
        SAY "- Information about the outcome of the last operation is corrupt."
        SAY ""
        SAY "Please perform the operation again or consult your system administrator."
        SAY ""
        "@PAUSE"
    END
    RETURN

GetInfoPath: PROCEDURE
    Path = ""
    Dir = GetSavDirectory()
    IF Dir \= "" THEN DO
        IF RIGHT(Dir, 1) \= "\" THEN
            Dir = Dir || "\"
        Path = Dir || "SETUP.INF"
    END
    RETURN Path

GetSavDirectory: PROCEDURE
    Dir = SysIni("USER", "SOPHOS_Anti-Virus", "Workstation")
    Dir = STRIP(Dir, "T", '0'X)
    IF Dir = "ERROR:" THEN DO
        PARSE SOURCE . . CmdPath
        Dir = FILESPEC("D", CmdPath) || FILESPEC("P", CmdPath)
    END
    RETURN Dir

GetStatusValue: PROCEDURE
    ARG Filename
    Filename = SubstituteFilename(Filename)
    Line = LINEIN(Filename)
    CALL STREAM Filename, "C", "CLOSE"
    Value = -1
    IF DATATYPE(Line, "W") THEN
        Value = 0 + Line
    RETURN Value

SubstituteFilename: PROCEDURE
    ARG Filename
    RETURN TRANSLATE(Filename, " ", "_")

FileExists: PROCEDURE
    ARG Filename
    Found = 0
    IF SysFileTree(Filename, Files, "FO") = 0 THEN
        IF Files.0 = 1 THEN
            Found = 1
    RETURN Found
